components/base/urls.py
from django.contrib import admin
from django.urls import path, include
from django.views.generic.base import TemplateView

app_name= 'base'

urlpatterns = [
    path('', TemplateView.as_view(template_name="home.html"), name='base_page'),
]

components/components/urls.py
from django.contrib import admin
from django.urls import path, include
from django.contrib.staticfiles.urls import static
from django.contrib.staticfiles.urls import staticfiles_urlpatterns
from . import settings

handler404 = 'base.views.handler404'

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('base.urls')),
    path('accounts/', include('accounts.urls')),
    path('predict/', include('image_process.urls')),
    path('', include('portfolio.urls')),
    path('', include('contact_us.urls')),
    path('', include('two_factor_authentication.urls'))
]

#urlpatterns += staticfiles_urlpatterns()
#urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

components/image_process/urls.py
from django.contrib import admin
from django.urls import path, include
from image_process import views
from django.views.generic.base import TemplateView

app_name= 'image_process'

urlpatterns = [
    path('human-face-age-gender/', views.UploadPhotoView.as_view(), name='predict_face'),
]

components/image_process/models.py
from django.db import models
import os 
import datetime
from django.conf import settings
from django.core.files.storage import FileSystemStorage

def user_directory_path(instance, filename):
	timestampe = str(datetime.datetime.now().timestamp()).replace(".","_")
	fname = "image_"+ timestampe
	name, ext = os.path.splitext(filename)
	file_path = str(fname) + str(ext)
	return "static/images/age_gender_detection/input_images/{0}".format(file_path)

class UploadImage(models.Model):
	upload_storage = FileSystemStorage(location="image_process", base_url='/image_process')
	user = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE, null=True)
	image = models.ImageField(upload_to=user_directory_path, storage=upload_storage, default=None)
	created_on = models.DateTimeField(auto_now_add=True)

components/image_process/forms.py
from django import forms
from django.forms import ModelForm
import cv2 as opencv
from .validators import FileValidator
from .models import UploadImage

class UploadPhotoForm(ModelForm):
	#upload_photo = forms.ImageField(label="Upload your photo", error_messages={'invalid_image':'Please upload a valid image'})
	#name = forms.CharField()
	class Meta:
		model = UploadImage
		fields = ('image',)

	def clean_image(self):
		image = self.cleaned_data.get('image')
		#FileValidator(max_width=4000, max_height=4000).check_width_height(image)
		#FileValidator().check_file_extenstion(upload_photo)
		return image

components/image_process/views.py
from django.shortcuts import render
from django.views.generic.edit import FormView
from image_process import forms
from django.views import View
from django.urls import reverse_lazy, reverse
from django.shortcuts import render, redirect, loader
from django.http import HttpResponse, HttpResponseRedirect, JsonResponse
from accounts.models import  User
from .models import UploadImage
from .processors import image_reader
from django.conf import settings
import os

class UploadPhotoView(View):
	form_class = forms.UploadPhotoForm
	template_name = "upload_photo.html"
	success_url = reverse_lazy("image_process:predict_face")
	
	def get(self, request):
		#return HttpResponse(os.path.dirname(os.path.abspath(__file__)))
		form = forms.UploadPhotoForm()
		context = {'form':form}
		return render(request, template_name=self.template_name, context={'form':form})

	def post(self, request):
		form = forms.UploadPhotoForm(request.POST, request.FILES)
		if form.is_valid():
			if request.user.is_authenticated:
				user = User.objects.get(id=request.user.id)
			else:
				user = None
			'''
			form_model = UploadImage(image=request.FILES['image'], user=user)
			form_model.save()
			stored_image = UploadImage.objects.get(id=form_model.id)
			input_image_path = stored_image.image.url
			'''
			app_name = request.resolver_match.app_name
			output_image = image_reader(request.FILES['image'].read(), app_name)
			#os.remove(settings.BASE_DIR+input_image_path)
			#os.remove(settings.BASE_DIR+output_image_path)
			#stored_image.delete()
			return JsonResponse({'image_url':output_image})
		else:
			error_messages = {
					"1":"Please upload valid image", 
					"2":"Image size should be lesser than 1070 X 720"
					}
			return JsonResponse({"error":error_messages})
	'''
	def form_valid(self, form):
		image = self.request.FILES['upload_photo']
		template = loader.get_template("result.html")
		context = self.get_result()
		return HttpResponse(template.render(context, self.request))
	'''
	def get_result(self):
		return {'result': {'gender':'Male', 'age': 25} }

components/image_process/templates/result.html
<p>Gender : <h3>{{ result.gender }}</h3></p>
<p>Age : <h3>{{ result.age }}</h3></p>
<a href="{% url 'image_process:upload_photo' %}">Refersh</a>

components/image_process/templates/upload_photo.html
{% extends 'base.html' %}
{% load static %}
{% block meta_tags %}<title>Predict Human Face, Age and Gender - Components</title>
        <meta name="description" content="Detect Human face, age and gender from image using opencv module.">{% endblock %}
{% block content %}
    <style>
        .loader
        {
              position: fixed;
              overflow: hidden;
              z-index: 5000;
              top: 0;
              left: 0;
              text-align: center;
              background: #ffffff8c;
              color: #fff;
                margin-left: auto;
                margin-right: auto;
                display: block;
        }
        .loader {
            display:none;   
        }
    </style>
    <div class="subcontainer">
        <div class="row">
            <div class="col-md-12 col-sm-12 col-xs-12 col-lg-12">
                <h3 class="text-center pb-2"><u>Predict Human Face, Age & Gender</u></h3>
            </div>
          <div class="col-md-5 col-sm-12 col-xs-12 col-lg-3 pb-3">
            <h5>Sample output images</h5>
            <img src="{% static 'image_process/images/examples/example_1.png' %}" width="300" height="250"class="img-responsive"/>
            <img src="{% static 'image_processimages/examples/example_2.png' %}" width="300" height="250" class="img-responsive pt-3"/>
          </div>      
          <div class="col-md-7 col-sm-12 col-xs-12 col-lg-8">
            <p>The purpose of this component is find the human <strong>face</strong> from uploaded photo and get <strong>AGE</strong> and <strong>Gender</strong> of the found faces. We have used <strong>Opencv</strong> module to achive this also we have used <strong>Deep learning</strong>.</p>
            <form class="upload=photo" method="POST" id="upload_photo" enctype="multipart/form-data">
                <div class="col-md-12 col-sm-12 col-xs-12 col-lg-12">
                    <div class="row">
                        <div class="form-group">
				            <label for="id_image">Please upload photo</label>
                            <input type="file" name="{{form.image.html_name}}" accept="image/*" class="form-control-file" required="" id="{{form.image.id_for_label}}">
                            {{ form.image.errors }}
                            {% csrf_token %}
                        </div>
                    </div>
                </div>
                <div>
                    <ul>
                        <li>We are not storing your uploded image anywhere in our server.</li>
                        <li>Plese give your feedback to improve this component <a>Feedback.</a></li>
                    </ul>
                </div>
                <div class="col-md-12 col-sm-12 col-xs-12 col-lg-12">
                    <div class="row">
                        <div class="form-group">
                            <button type="submit" class="btn btn-success">Upload</button>
                        </div>
                    </div>
                    <div class="row">
                        <div class="loader">
                            <img src="{% static 'image_process/loading.gif' %}" class="img-responsive"/>
                        </div>
                    </div>
                </div>
            </form>
            <div class="col-md-12 col-sm-6 col-xs-6 col-lg-12">
                <div class="row">
                    <div class="output_image"></div>
                </div>
            </div>
          </div>
        </div>
    </div>
    <script type="text/javascript">
        $(document).ajaxStart(function(){
            $(".loader").show()    
        });
        $(document).on('submit', '#upload_photo',function(e){
            e.preventDefault();
	    $(".output_image").html("")
            var formData = new FormData($(this).get(0))
            $.ajax({
                type:'POST',
                url:'{% url "image_process:predict_face" %}',
                data:formData,
                cache: false,
                processData: false,
                contentType: false,
                success:function(response){
                    if (response.error) {
                        var error = "<ul class='errorlist'>";
                        $.each(response.error, function(key, value){
                            error += "<li>"+value+"</li>"
                        })
                        error +="</ul>";
                        $(".output_image").html(error)
                    } 
                    else{
                        //img = '<img src="'+ response.image_url+'">'
                        //var image = new Image(100, 2000);
                        //image.src = 'data:image/png;base64,'+ response.image_url
                        //image.class = "img-responsive"
                        //document.body.appendChild(image);
                        image_src = 'data:image/png;base64,'+ response.image_url
                        img = '<div>Output:<img src="'+ image_src+'" class="img-responsive_"></div>'
                        $(".output_image").html(img)
                    }
                },
                error : function(xhr,errmsg,err) {
                console.log("Error"); // provide a bit more info about the error to the console
            }
            });
        });
        $(document).ajaxStop(function(){
            $(".loader").hide()    
        });
    </script>
{% endblock %}